import java.lang.*;

class Worker extends Thread
{
	private Agent mAgent;
	private Srodowisko mEnv;
	private boolean mLastResult = true;
	private boolean mDone = false;
	
	static public Object mutex = new Object();

	Worker(Srodowisko env, Agent a)
	{
		mAgent = a;
		mEnv = env;
	}
	
	public void run() 
	{
		while(!mDone)
		{
			synchronized (mutex)
			{
				mEnv.dump();
				System.out.println("");	
				mLastResult = mAgent.run();	
			}		
			
			yield(); /* Wymuszamy przelaczenie watku */			
		}
	}
	
	public boolean getLastResult()
	{
		return mLastResult;
	}
	
	public void exit()
	{
		mDone = true;
	}
}

public class Glinski
{
	public static void main(String arg[])
	{
		Srodowisko env = new Srodowisko(4, 4);
		Agent[] a = new Agent[3];
		
		Worker[] w = new Worker[a.length];
		int wys = env.getWys(), szer = env.getSzer();		
		for(int i = 0; i < a.length; i++)
		{
			a[i] = new Agent();
			env.getPole(i % szer, i / wys).setAgent(a[i]);
		}
		/* Wersja jedno-wtkowa: */
		/*
		boolean done;
		do
		{
			done = true;
			env.dump();
			System.out.println("");
			
			for(int i = 0; i < a.length; i++)
			{
				if (a[i].run())
				{
					//System.out.println("a[" + i + "] = true");
					done = false;
				}
			}
		} while(!done);*/
		
		/* Wersja wielo-wtkowa: */
		synchronized(Worker.mutex)
		{
			for(int i=0;i<a.length;i++)
			{
				w[i] = new Worker(env, a[i]);
				w[i].start();
			}		
		}
		
		boolean done = false;
		while(!done)
		{
			done = true;
			synchronized(Worker.mutex)
			{				
				for(int i = 0; i < w.length; i++)
				{
					if (w[i].getLastResult())
						done = false;
				}
			}
			
			Thread.yield();
		}
		
		synchronized(Worker.mutex)
		{
			/* Zakanczamy wszystkie watki */
			for(int i = 0; i < w.length; i++)
			{
				w[i].exit();
			}
		}
	}
}
