
public class Srodowisko
{
	private int mWys = 3;
	private int mSzer = 3;
	private Pole[][] mPola;
	
	public Srodowisko(int wys, int szer)
	{
		mWys = wys;
		mSzer = szer;
		mPola = new Pole[mSzer][mWys];		
		for(int x=0;x<mSzer;x++)
		{
			for(int y=0;y<mWys;y++)
			{
				mPola[x][y] = new Pole(this, x, y, 2 * x + y + 1);
			}
		}
	}
	
	public Pole getPole(int x, int y)
	{
		if ((x < 0) || (x >= mSzer) || (y < 0) || (y >= mWys))
			return null;
		
		return mPola[x][y];
	}
	
	public int getWys()
	{
		return mWys;
	}
	
	public int getSzer()
	{
		return mSzer;
 	}
	
	public void dump()
	{
		int x, y;
		for(y=0;y<mWys;y++)
		{
			for(x=0;x<mSzer;x++)
			{
				Pole p = getPole(x, y);
				if (p.getAgent() != null)				
					System.out.print("A ");
				else
					System.out.print(p.getWart() + " ");
			}
			System.out.println("");
		}
	}
}
